/*
 * $Id: control.prg 672 2011-07-28 17:51:55Z concentra $
 */

/*
 * HMG Source Code
 *
 * Copyright 2002-2010 Roberto Lopez <mail.box.hmg@gmail.com>
 * http://sites.google.com/site/hmgweb/
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or( at your option ) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License FOR more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this software; see the file COPYING. IF not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA( or
 * visit the web site http://www.gnu.org/ ).
 *
 * As a special exception, you have permission FOR additional uses of the text
 * contained in this release of HMG.
 *
 * The exception is that, IF you link the HMG library with other
 * files to produce an executable, this does not by itself cause the resulting
 * executable to be covered by the GNU General Public License.
 * Your use of that executable is in no way restricted on account of linking the
 * HMG library code into it.
 */

#include "hbclass.ch"
#include "common.ch"
#include "hbqtgui.ch"
#include "hmg.ch"

/*----------------------------------------------------------------------*/

memvar oCurrentPage

/*----------------------------------------------------------------------*/

CLASS CONTROL FROM BASIC

   // Internal Data
   DATA cClass                                    INIT   "CONTROL"
   DATA lSort                                     INIT   NIL
   DATA cType                                     INIT   NIL
   DATA lBold                                     INIT   NIL
   DATA lEnabled                                  INIT   .T.
   DATA lTransparent                              INIT   NIL
   DATA lMultiline                                INIT   NIL
   DATA nHelpId                                   INIT   NIL
   DATA lTabStop                                  INIT   NIL
   DATA cTooltip                                  INIT   NIL
   DATA cPicture                                  INIT   NIL
   DATA bOnChange                                 INIT   NIL
   DATA cField                                    INIT   NIL
   DATA bOnEnter                                  INIT   NIL
   DATA lReadOnly                                 INIT   NIL
   DATA aDisabledBackColor                        INIT   NIL
   DATA aDisabledFontColor                        INIT   NIL
   DATA nAlignment                                INIT   NIL
   DATA lFlat                                     INIT   NIL
   DATA oTabObject                                INIT   NIL
   DATA nTabPage                                  INIT   NIL
   DATA aImage                                    INIT   NIL
   DATA nItemCount                                INIT   NIL
   DATA aItems                                    INIT   NIL
   DATA bOnDblClick                               INIT   NIL
   DATA lMultiSelect                              INIT   .F.
   DATA nImageWidth                               INIT   NIL
   DATA nImageHeight                              INIT   NIL

   // Properties
   METHOD Sort                                    SETGET
   METHOD MultiSelect                             SETGET
   METHOD Parent                                  SETGET
   METHOD Caption                                 SETGET
   METHOD Enabled                                 SETGET
   METHOD Transparent                             SETGET
   METHOD Multiline                               SETGET
   METHOD HelpId                                  SETGET
   METHOD TabStop                                 SETGET
   METHOD ToolTip                                 SETGET
   METHOD Picture                                 SETGET
   METHOD Field                                   SETGET
   METHOD OnEnter                                 SETGET
   METHOD ReadOnly                                SETGET
   METHOD DisabledBackColor                       SETGET
   METHOD DisabledFontColor                       SETGET
   METHOD Alignment                               SETGET
   METHOD Flat                                    SETGET
   METHOD Image                                   SETGET
   METHOD ItemCount                               SETGET
   METHOD Items                                   SETGET
   METHOD ImageWidth                              SETGET
   METHOD ImageHeight                             SETGET

   // Events
   METHOD OnGotFocus                              SETGET
   METHOD OnLostFocus                             SETGET
   METHOD OnChange                                SETGET
   METHOD OnDblClick                              SETGET

   // Methods
   METHOD Release
   METHOD SetFocus
   METHOD Refresh
   METHOD Save
   METHOD DeleteItem
   METHOD DeleteAllItems
   METHOD ProcessKeyPressed

ENDCLASS

/*----------------------------------------------------------------------*/
//                                Methods
/*----------------------------------------------------------------------*/

METHOD SetFocus() CLASS CONTROL

   ::oQTObject:SetFocus()

   RETURN Self

/*----------------------------------------------------------------------*/

METHOD Refresh() CLASS CONTROL

   RETURN Self

/*----------------------------------------------------------------------*/

METHOD Save() CLASS CONTROL

   RETURN Self

/*----------------------------------------------------------------------*/

METHOD Release() CLASS CONTROL

   LOCAL i

   // Remove from the parent pool control
   FOR i := 1 TO len(::oParent:aControls)
      IF ! hb_IsNil( ::oParent:aControls[ i ] )
         IF ::oParent:aControls[ i ]:Name == ::cName
            ::oParent:aControls[ i ] := Nil
         ENDIF
      ENDIF
   NEXT i

   Super:Release()  // it calls :close()

   RETURN Self

/*----------------------------------------------------------------------*/

METHOD DeleteItem( nValue ) CLASS CONTROL

   HB_SYMBOL_UNUSED( nValue )

   RETURN Self

/*----------------------------------------------------------------------*/

METHOD DeleteAllItems() CLASS CONTROL

   RETURN Self

/*----------------------------------------------------------------------*/

METHOD ProcessKeyPressed( oEvent ) CLASS CONTROL

  LOCAL nKey         := oEvent:key()
  LOCAL nModifiers   := oEvent:modifiers()

  IF nKey == Qt_Key_Return .OR. nKey == Qt_Key_Enter
    EVAL( ::bOnEnter )
    ::SendEvent( Qt_Key_Tab, Qt_NoModifier )
    RETURN .T.
  ENDIF

  HB_SYMBOL_UNUSED( nModifiers )

RETURN .F.

/*----------------------------------------------------------------------*/
//                             Properties
/*----------------------------------------------------------------------*/

METHOD ItemCount( nValue ) CLASS CONTROL

   IF PCOUNT() == 0
      RETURN ::nItemCount
   ELSEIF VALTYPE( nValue ) == "N"
      ::nItemCount := nValue
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD Sort( lValue ) CLASS CONTROL

   IF PCOUNT() == 0
      RETURN ::lSort
   ELSEIF VALTYPE( lValue ) == "L"
      ::lSort := lValue
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD MultiSelect( lValue ) CLASS CONTROL

   IF PCOUNT() == 0
      RETURN ::lMultiSelect
   ELSEIF VALTYPE( lValue ) == "L"
      ::lMultiSelect := lValue
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD Items( aValue ) CLASS CONTROL

   IF PCOUNT() == 0
      RETURN ::aItems
   ELSEIF VALTYPE( aValue ) == "A"
      ::aItems := aValue
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD Image( aValue ) CLASS CONTROL

   IF PCOUNT() == 0
      RETURN ::aImage
   ELSEIF VALTYPE( aValue ) == "A"
      ::aImage := aValue
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD Alignment( lValue ) CLASS CONTROL

   IF PCOUNT() == 0
      RETURN ::lAlignment
   ELSEIF VALTYPE( lValue ) == "L"
      ::lAlignment := lValue
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD Flat( lValue ) CLASS CONTROL
   LOCAL cStyleSheet

   IF PCOUNT() == 0
      RETURN ::lFlat
   ELSEIF VALTYPE( lValue ) == "L"
      ::lFlat := lValue
      cStyleSheet :=    ::oQTObject:StyleSheet()
      cStyleSheet :=    StrTran( cStyleSheet , 'border:none;', '' )
      IF ::lFlat == .T.
         cStyleSheet += 'border:none;'
      ENDIF
      ::oQTObject:setStyleSheet( cStyleSheet )
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD Transparent( lValue ) CLASS CONTROL

   HB_SYMBOL_UNUSED( lValue )

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD DisabledBackColor( aValue ) CLASS CONTROL

   IF PCOUNT() == 0
      RETURN ::aDisabledBackColor
   ELSEIF VALTYPE( aValue ) == "A"
      ::aDisabledBackColor := aValue
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD DisabledFontColor( aValue ) CLASS CONTROL

   IF PCOUNT() == 0
      RETURN ::aDisabledFontColor
   ELSEIF VALTYPE( aValue ) == "A"
      ::aDisabledFontColor := aValue
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD ReadOnly( lValue ) CLASS CONTROL

   IF PCOUNT() == 0
      RETURN    ::oQTObject:ReadOnly()
   ELSEIF VALTYPE( lValue ) == "L"
      ::oQTObject:SetReadOnly( lValue )
      ::lReadOnly := lValue
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD Field( cValue ) CLASS CONTROL

   IF PCOUNT() == 0
      RETURN ::cField
   ELSEIF PCOUNT() == 1
      ::cField := cValue
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD Parent( oValue ) CLASS CONTROL
   LOCAL i

   IF PCOUNT() == 0
      RETURN ::oParent
   ENDIF

   // If the parent is already the one, do nothing
   IF VALTYPE(::oParent) == "U" .OR. oValue:cName != ::oParent:cName

      // Remove from the old parent stack
      IF VALTYPE(::oParent) != "U"
         FOR i := 1 To Len( ::oParent:aControls )
            IF ::oParent:aControls[i]:Name == ::cName
               adel( ::oParent:aControls , i )
               asize( ::oParent:aControls , len( ::oParent:aControls ) - 1 )
            ENDIF
         NEXT i
         ::oParent:DelData( ::cName )
      ENDIF

      ::oParent := oValue

      // Add to the new parent stack
      ::oParent:AddData( ::cName, Self )
      AADD( oValue:aControls , Self )

   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD Enabled( lValue ) CLASS CONTROL

   LOCAL cStyleSheet := "", lChanged := .F.

   IF PCOUNT() == 0
      RETURN ::lEnabled
   ELSEIF VALTYPE( lValue ) == "L"
      ::lEnabled := lValue
      ::oQTObject:SetEnabled( ::lEnabled )
      IF lValue == .F.
         IF VALTYPE( ::aDisabledFontColor ) == "A"
            cStyleSheet += "color:#" + hb_numtohex( ::aDisabledFontColor[1], 2 ) + hb_numtohex( ::aDisabledFontColor[2], 2 ) + hb_numtohex( ::aDisabledFontColor[3], 2 ) + ";"
            lChanged := .T.
         ENDIF
         IF VALTYPE( ::aDisabledBackColor ) == "A"
            cStyleSheet += "background-color:#" + hb_numtohex( ::aDisabledBackColor[1], 2 ) + hb_numtohex( ::aDisabledBackColor[2], 2 ) + hb_numtohex( ::aDisabledBackColor[3], 2 ) + ";"
            lChanged := .T.
         ENDIF
      ELSE
         IF VALTYPE( ::aFontColor ) == "A"
            cStyleSheet += "color:#" + hb_numtohex( ::aFontColor[1], 2 ) + hb_numtohex( ::aFontColor[2], 2 ) + hb_numtohex( ::aFontColor[3], 2 ) + ";"
            lChanged := .T.
         ENDIF
         IF VALTYPE( ::aBackColor ) == "A"
            cStyleSheet += "background-color:#" + hb_numtohex( ::aBackColor[1], 2 ) + hb_numtohex( ::aBackColor[2], 2 ) + hb_numtohex( ::aBackColor[3], 2 ) + ";"
            lChanged := .T.
         ENDIF
      ENDIF
      IF lChanged == .T. ; Self:StyleSheet( cStyleSheet ) ; ENDIF
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD Caption( cValue ) CLASS CONTROL

   IF PCOUNT() == 0
      RETURN ::oQTObject:Text()
   ELSEIF VALTYPE( cValue ) == "C"
      ::cCaption := cValue
      ::oQTObject:setText( ::cCaption )
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD Picture( cValue ) CLASS CONTROL

   LOCAL oIMG

   IF PCOUNT() == 0
      RETURN ::cPicture
   ELSEIF VALTYPE( cValue ) == "C"
      ::cPicture := cValue
      oImg := QPixmap( ::cPicture )
      oIMG := oIMG:scaledToHeight( ::oQTObject:height )
      oIMG := oIMG:scaledToWidth( ::oQTObject:width )
      ::oQTObject:setPixmap( oIMG )
      __MVXRelease( "oIMG" )
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD Multiline( lValue ) CLASS CONTROL

   IF PCOUNT() == 0
      RETURN ::lMultiline
   ELSEIF VALTYPE( lValue ) == "L"
      ::lMultiline := lValue
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD TabStop( lValue ) CLASS CONTROL

   IF PCOUNT() == 0
      RETURN If( ::oQTObject:FocusPolicy() == 15 , .T. , .F. )
   ELSEIF VALTYPE( lValue ) == "L"
      ::lTabStop := lValue
      IF ::lTabStop == .T.
         ::oQTObject:SetFocusPolicy( 15 )
      ELSE
         ::oQTObject:SetFocusPolicy( 2 )
      ENDIF
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD HelpId( nValue ) CLASS CONTROL

   IF PCOUNT() == 0
      RETURN ::nHelpId
   ELSEIF VALTYPE( nValue ) == "N"
      ::nHelpId := nValue
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD ToolTip( cValue ) CLASS CONTROL

   IF PCOUNT() == 0
      RETURN ::oQTObject:ToolTip()
   ELSEIF VALTYPE( cValue ) == "C"
      ::cToolTip := cValue
      ::oQTObject:SetToolTip( ::cToolTip )
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD ImageWidth( nValue ) CLASS CONTROL

   IF PCOUNT() == 0
      RETURN ::nImageWidth
   ELSEIF VALTYPE( nValue ) == "N"
      ::nImageWidth := nValue
      IF VALTYPE( ::nImageWidth ) == "N" .AND. VALTYPE( ::nImageHeight ) == "N"
         ::oQTObject:setIconSize( QSize( ::nImageWidth, ::nImageHeight ) )
      ENDIF
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD ImageHeight( nValue ) CLASS CONTROL

   IF PCOUNT() == 0
      RETURN ::nImageHeight
   ELSEIF VALTYPE( nValue ) == "N"
      ::nImageHeight := nValue
      IF VALTYPE( ::nImageWidth ) == "N" .AND. VALTYPE( ::nImageHeight ) == "N"
         ::oQTObject:setIconSize( QSize( ::nImageWidth, ::nImageHeight ) )
      ENDIF
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/
//                               Events
/*----------------------------------------------------------------------*/

METHOD OnDblClick( bValue ) CLASS CONTROL

   IF PCOUNT() == 0
      RETURN ::bOnDblClick
   ELSEIF VALTYPE( bValue ) == "B"
      ::bOnDblClick := bValue
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD OnChange( bValue ) CLASS CONTROL

   IF PCOUNT() == 0
      RETURN ::bOnChange
   ELSEIF VALTYPE( bValue ) == "B"
      ::bOnChange := bValue
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD OnGotFocus( bValue ) CLASS CONTROL

   IF PCOUNT() == 0
      RETURN   ::bOnGotFocus
   ELSEIF VALTYPE( bValue ) == "B"
      ::bOnGotFocus := bValue
      IF .NOT. ::oQTObject:connect( QEvent_FocusIn , ::bOnGotFocus )
            // We can not connect this event now ... Error
      ENDIF
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD OnLostFocus( bValue ) CLASS CONTROL

   IF PCOUNT() == 0
      RETURN   ::bOnlostFocus
   ELSEIF VALTYPE( bValue ) == "B"
      ::bOnLostFocus := bValue
      IF .NOT. ::oQTObject:connect( QEvent_FocusOut , ::bOnLostFocus )
            // Can't connect the event... error
      ENDIF
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/

METHOD OnEnter( bValue ) CLASS CONTROL

   IF PCOUNT() == 0
      RETURN ::bOnEnter
   ELSEIF VALTYPE( bValue ) == "B"
      ::bOnEnter := bValue
      ::oQtObject:connect( QEvent_KeyPress, {|e| ::ProcessKeyPressed( e ) } )
   ENDIF

   RETURN NIL

/*----------------------------------------------------------------------*/
